static variable window = NULL;

define create_wmhints (test)
{
   if (window == NULL) {

	% This example sets the icon that will be displayed by 
	% the window manager when the toplevel is iconified.

	window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
	() = g_signal_connect (window, "destroy",&gtk_widget_destroyed,&window);

	gtk_window_set_title (window, "WM Hints");
	gtk_container_set_border_width (window,0);
	gtk_window_set_default_size(window, 200, 150);

	%  Realize the toplevel to create its drawable window
	gtk_widget_realize (window);
	variable drawable = gtk_widget_get_window(window);

	% Now specify the icon.  Note how missing parameters (denoted
	% by empty commas) are shorthand for NULL in S-Lang
	variable pixmap = gdk_pixmap_create_from_xpm(drawable,,,
						"../images/test.xpm");
	gdk_window_set_icon (drawable, NULL, pixmap, );
	gdk_window_set_icon_name (drawable, "WMHints Test Icon");
	gdk_window_set_decorations (drawable, GDK_DECOR_ALL | GDK_DECOR_MENU);
	gdk_window_set_functions (drawable, GDK_FUNC_ALL | GDK_FUNC_RESIZE);
      
	variable vbox = gtk_vbox_new (FALSE, 0);
	gtk_container_add ( window, vbox);

	variable label = gtk_label_new ("Iconize me to see the WM\n"+
	      				"display a non-default icon!");
	gtk_widget_set_usize (label, 150, 100);
	gtk_box_pack_start (vbox, label, TRUE, TRUE, 0);
	test.lower = generic_close_button(vbox,window);
   }

   if (gtk_widget_visible (window))
	gtk_widget_destroy (window);
   else
	gtk_widget_show_all (window);
}
